; PureBasic Visual Designer v3.95 build 1485 (PB4Code)

;Michael Kcher (six1) 2009
;Sample application, showing ATMEL AVR309.dll usage
;not all posible functions are included! There is much more, one can do with!
;
;based on atmel avr309.dll, App.Note "AVR309: USB to UART Protocol Converter" by ATMEL



;{- Enumerations / DataSections
;{ Windows
Enumeration
  #Window_0
EndEnumeration
;}
;{ Gadgets
Enumeration
  #COM_String_0
  #send_ser
  #ComboBox_Baud
  #Text_5
  #Frame3D_6
  #Frame3D_7
  #Text_8
  #Text_9
  #Text_10

  #port_b_0=100
  #port_b_1=#port_b_0+1
  #port_b_2=#port_b_0+2
  #port_b_3=#port_b_0+3
  #port_b_4=#port_b_0+4
  #port_b_5=#port_b_0+5
  #port_b_6=#port_b_0+6
  #port_b_7=#port_b_0+7
  #Port_B_direction=#port_b_0+8
  #port_b=#port_b_0+9

  #port_c_0=110
  #port_c_1=#port_c_0+1
  #port_c_2=#port_c_0+2
  #port_c_3=#port_c_0+3
  #port_c_4=#port_c_0+4
  #port_c_5=#port_c_0+5
  #port_c_6=#port_c_0+6
  #port_c_7=#port_c_0+7
  #Port_C_direction=#port_c_0+8
  #port_c=#port_c_0+9

  #port_d_0=120
  #port_d_1=#port_d_0+1
  #port_d_2=#port_d_0+2
  #port_d_3=#port_d_0+3
  #port_d_4=#port_d_0+4
  #port_d_5=#port_d_0+5
  #port_d_6=#port_d_0+6
  #port_d_7=#port_d_0+7
  #Port_D_direction=#port_d_0+8
  #port_d=#port_d_0+9

  #Text_23
  #Poll_Timer
  #Receive_Timer
  #Frame3D_40
  #State_Text_1
  #RX_Text
  #Text_46
  #Spin_47
  #send_byte_ser
  #Frame3D_51
EndEnumeration
;}
;{ Fonts

Enumeration
  #Font_Text_5
  #Font_Frame3D_6
  #Font_Frame3D_7
  #Font_Text_8
  #Font_Text_9
  #Font_Text_10
  #Font_Port_B_direction
  #Font_Port_C_direction
  #Font_Port_D_direction
  #Font_Frame3D_40
  #Font_State_Text_1
  #Font_Spin_47
  #Text_49
  #Text_50
  #Font_Frame3D_51
EndEnumeration
;}

;{ *** Globale Variablen ***
  Global pVendorID.l, pProductID.l
  Global PORTB.c=0, PORTC.c=0, PORTD.c=0, UsedPorts.c=0
  Global INPORTB.c, INPORTC.c, INPORTD.c
  Global OUTPORTB.c, OUTPORTC.c, OUTPORTD.c
  Global ret.l, RS232BufferLength.l=100, InfraBufferLength.l=255
  
  Dim DataPortDirection.c(2)
  Dim InputRS232Data.c(RS232BufferLength) ;Buffer Empfang Serielle  array
  Dim InputInfraData.c(InfraBufferLength)   ;Empfang Infrarot Empfnger, soll graphisch dargestellt werden.
  
  #VendorID = $03EB    ; Vendor ID "ATMEL Corporation"
;  #ProductID = $21FE   ; ProductID "AVR309:USB to UART protocol converter (simple) Tiny2313"
  #ProductID = $21FF   ; ProductID "AVR309:USB to UART protocol converter AT-Mega8"

  
;*** Constants ***
  #NO_ERROR = 0;
  #DEVICE_NOT_PRESENT = 1;
  #NO_DATA_AVAILABLE = 2;
  #INVALID_BAUDRATE = 3;
  #OVERRUN_ERROR = 4;
  #INVALID_DATABITS = 5;
  #INVALID_PARITY = 6;
  #INVALID_STOPBITS = 7;
  
;}

;{ *** AVR309.dll ***

Define AVR309_DLL.l = OpenLibrary(#PB_Any, "AVR309.dll")


If AVR309_DLL
    Prototype  pDoGetInfraCode (Array, dummy.l, DiagramLength.l); As integer;
    Prototype  pDoSetDataPortDirection (DirectionByte.c); As integer;
    Prototype  pDoGetDataPortDirection (DataDirectionByte.c); As integer;
    Prototype  pDoSetOutDataPort (DataOutByte.c); As integer;
    Prototype  pDoGetOutDataPort (DataOutByte.c); As integer;
    Prototype  pDoGetInDataPort (DataInByte.c); As integer;
    Prototype  pDoEEPROMRead (DataInByte.c); As integer;
    Prototype  pDoEEPROMWrite (DataOutByte.c); As integer;
    Prototype  pDoRS232Send (DataOutByte.c); As integer;
    Prototype  pDoRS232Read (DataInByte.c); As integer;
    Prototype  pDoSetRS232Baud (BaudRate.i); As integer;
    Prototype  pDoGetRS232Baud (BaudRate.i); As integer;
    Prototype  pDoGetRS232Buffer ( Array, dummy.l, RS232BufferLength.i); As integer;
    Prototype  pDoRS232BufferSend (Array, dummy.l, RS232BufferLength.i); As integer;
    Prototype  pDoSetRS232DataBits (DataBits.c); As integer;
    Prototype  pDoGetRS232DataBits (DataBits.c); As integer;
    Prototype  pDoSetRS232Parity (Parity.c); As integer;
    Prototype  pDoGetRS232Parity (Parity.c); As integer;
    Prototype  pDoSetRS232StopBits (StopBits.c); As integer;
    Prototype  pDoGetRS232StopBits (StopBits.c); As integer;
    Prototype  pDoSetDataPortDirections (DirectionByteB.c, DirectionByteC.c, DirectionByteD.c, UsedPorts.c); As integer;
    Prototype  pDoGetDataPortDirections (DataDirectionByteB.c, DataDirectionByteC.c, DataDirectionByteD.c, UsedPorts.c); As integer;
    Prototype  pDoSetOutDataPorts (DataOutByteB.c, DataOutByteC.c, DataOutByteD.c, UsedPorts.c); As integer;
    Prototype  pDoGetOutDataPorts (DataOutByteB.c, DataOutByteC.c, DataOutByteD.c, UsedPorts.c); As integer;
    Prototype  pDoGetInDataPorts ( DataInByteB.c, DataInByteC.c, DataInByteD.c, UsedPorts.c); As integer;


    Global DoGetInfraCode.pDoGetInfraCode = GetFunction(AVR309_DLL, "DoGetInfraCode") ; ( *TimeCodeDiagram.c, DiagramLength.l) as integer;
    Global DoSetDataPortDirection.pDoSetDataPortDirection = GetFunction(AVR309_DLL, "DoSetDataPortDirection") ; ( DirectionByte.c) as integer;
    Global DoGetDataPortDirection.pDoGetDataPortDirection = GetFunction(AVR309_DLL, "DoGetDataPortDirection") ; ( DataDirectionByte.c) as integer;
    Global DoSetOutDataPort.pDoSetOutDataPort = GetFunction(AVR309_DLL, "DoSetOutDataPort") ; ( DataOutByte.c) as integer;
    Global DoGetOutDataPort.pDoGetOutDataPort = GetFunction(AVR309_DLL, "DoGetOutDataPort") ; ( DataOutByte.c) as integer;
    Global DoGetInDataPort.pDoGetInDataPort = GetFunction(AVR309_DLL, "DoGetInDataPort") ; ( DataInByte.c) as integer;
    Global DoEEPROMRead.pDoEEPROMRead = GetFunction(AVR309_DLL, "DoEEPROMRead") ; ( Address.w, DataInByte.c ) as integer;
    Global DoEEPROMWrite.pDoEEPROMWrite = GetFunction(AVR309_DLL, "DoEEPROMWrite") ; ( Address.w, DataOutByte.c ) as integer;
    Global DoRS232Send.pDoRS232Send = GetFunction(AVR309_DLL, "DoRS232Send") ; ( DataOutByte.c ) as integer;
    Global DoRS232Read.pDoRS232Read = GetFunction(AVR309_DLL, "DoRS232Read") ; ( DataInByte.c ) as integer;
    Global DoSetRS232Baud.pDoSetRS232Baud = GetFunction(AVR309_DLL, "DoSetRS232Baud") ; ( BaudRate.i ) as integer;
    Global DoGetRS232Baud.pDoGetRS232Baud = GetFunction(AVR309_DLL, "DoGetRS232Baud") ; ( BaudRate.i ) as integer;
    Global DoGetRS232Buffer.pDoGetRS232Buffer = GetFunction(AVR309_DLL, "DoGetRS232Buffer") ; ( *RS232Buffer.c, RS232BufferLength.l ) as integer;
    Global DoRS232BufferSend.pDoRS232BufferSend = GetFunction(AVR309_DLL, "DoRS232BufferSend") ; ( *RS232Buffer.c, RS232BufferLength.l) as integer;

    Global DoSetRS232DataBits.pDoSetRS232DataBits = GetFunction(AVR309_DLL, "DoSetRS232DataBits") ; ( DataBits.c) as integer;
    Global DoGetRS232DataBits.pDoGetRS232DataBits = GetFunction(AVR309_DLL, "DoGetRS232DataBits") ; ( DataBits.c) as integer;
    Global DoSetRS232Parity.pDoSetRS232Parity = GetFunction(AVR309_DLL, "DoSetRS232Parity") ; ( Parity.c) as integer;
    Global DoGetRS232Parity.pDoGetRS232Parity = GetFunction(AVR309_DLL, "DoGetRS232Parity") ; ( Parity.c) as integer;
    Global DoSetRS232StopBits.pDoSetRS232StopBits = GetFunction(AVR309_DLL, "DoSetRS232StopBits") ; ( StopBits.c) as integer;
    Global DoGetRS232StopBits.pDoGetRS232StopBits = GetFunction(AVR309_DLL, "DoGetRS232StopBits") ; ( StopBits.c) as integer;

    Global DoSetDataPortDirections.pDoSetDataPortDirections = GetFunction(AVR309_DLL, "DoSetDataPortDirections") ; ( DirectionByteB.c, DirectionByteC.c, DirectionByteD.c, UsedPorts.c) as integer;
    Global DoGetDataPortDirections.pDoGetDataPortDirections = GetFunction(AVR309_DLL, "DoGetDataPortDirections") ; ( DataDirectionByteB.c, DataDirectionByteC.c, DataDirectionByteD.c, UsedPorts.c) as integer;
    Global DoSetOutDataPorts.pDoSetOutDataPorts = GetFunction(AVR309_DLL, "DoSetOutDataPorts") ; ( DataOutByteB.c, DataOutByteC.c, DataOutByteD.c, UsedPorts.c) as integer;
    Global DoGetOutDataPorts.pDoGetOutDataPorts = GetFunction(AVR309_DLL, "DoGetOutDataPorts") ; ( DataOutByteB.c, DataOutByteC.c, DataOutByteD.c, UsedPorts.c) as integer;
    Global DoGetInDataPorts.pDoGetInDataPorts = GetFunction(AVR309_DLL, "DoGetInDataPorts") ; ( DataInByteB.c, DataInByteC.c, DataInByteD.c, UsedPorts.c) as integer;
Else
    MessageRequester("Fehlermeldung", "Das Programm konnte die AVR309.dll Datei nicht ffnen", #PB_MessageRequester_Ok)
    End
EndIf

;}

Procedure Open_Window_0()
  If OpenWindow(#Window_0,  389, 55, 505, 447, "AVR309: USB to UART Protocol Converter", #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_TitleBar|#PB_Window_ScreenCentered)
    StringGadget(#COM_String_0, 20, 105, 150, 25, "")
    ButtonGadget(#send_ser, 175, 105, 40, 25, "Send", #PB_Button_Default)
    ComboBoxGadget(#ComboBox_Baud, 20, 65, 85, 20)
    TextGadget(#Text_5, 107, 68, 50, 15, "Bd 8N1")
    Frame3DGadget(#Frame3D_6, 5, 35, 490, 140, "Seriell")
    Frame3DGadget(#Frame3D_7, 5, 175, 490, 150, "Parallel")
    TextGadget(#Text_8, 15, 220, 60, 20, "Port-B")
    TextGadget(#Text_9, 15, 255, 60, 20, "Port-C")
    TextGadget(#Text_10, 15, 290, 60, 20, "Port-D")
    ButtonGadget(#port_b_7, 195, 215, 30, 30, "7", #PB_Button_Toggle)
    ButtonGadget(#port_b_6, 230, 215, 30, 30, "6", #PB_Button_Toggle)
    ButtonGadget(#port_b_5, 265, 215, 30, 30, "5", #PB_Button_Toggle)
    ButtonGadget(#port_b_4, 300, 215, 30, 30, "4", #PB_Button_Toggle)
    ButtonGadget(#port_b_3, 335, 215, 30, 30, "3", #PB_Button_Toggle)
    ButtonGadget(#port_b_2, 370, 215, 30, 30, "2", #PB_Button_Toggle)
    ButtonGadget(#port_b_1, 405, 215, 30, 30, "1", #PB_Button_Toggle)
    ButtonGadget(#port_b_0, 440, 215, 30, 30, "0", #PB_Button_Toggle)
    ButtonGadget(#Port_B_direction, 65, 215, 45, 30, "IN", #PB_Button_Toggle)
    ButtonGadget(#Port_C_direction, 65, 250, 45, 30, "IN", #PB_Button_Toggle)
    ButtonGadget(#Port_D_direction, 65, 285, 45, 30, "IN", #PB_Button_Toggle)
    TextGadget(#Text_23, 5, 430, 85, 15, "six1 2009")
    ButtonGadget(#port_c_7, 195, 250, 30, 30, "7", #PB_Button_Toggle)
    ButtonGadget(#port_d_7, 195, 285, 30, 30, "7", #PB_Button_Toggle)
    ButtonGadget(#port_c_6, 230, 250, 30, 30, "6", #PB_Button_Toggle)
    ButtonGadget(#port_d_6, 230, 285, 30, 30, "6", #PB_Button_Toggle)
    ButtonGadget(#port_c_5, 265, 250, 30, 30, "5", #PB_Button_Toggle)
    ButtonGadget(#port_d_5, 265, 285, 30, 30, "5", #PB_Button_Toggle)
    ButtonGadget(#port_c_4, 300, 250, 30, 30, "4", #PB_Button_Toggle)
    ButtonGadget(#port_d_4, 300, 285, 30, 30, "4", #PB_Button_Toggle)
    ButtonGadget(#port_c_3, 335, 250, 30, 30, "3", #PB_Button_Toggle)
    ButtonGadget(#port_d_3, 335, 285, 30, 30, "3", #PB_Button_Toggle)
    ButtonGadget(#port_c_2, 370, 250, 30, 30, "2", #PB_Button_Toggle)
    ButtonGadget(#port_d_2, 370, 285, 30, 30, "2", #PB_Button_Toggle)
    ButtonGadget(#port_c_1, 405, 250, 30, 30, "1", #PB_Button_Toggle)
    ButtonGadget(#port_d_1, 405, 285, 30, 30, "1", #PB_Button_Toggle)
    ButtonGadget(#port_c_0, 440, 250, 30, 30, "0", #PB_Button_Toggle)
    ButtonGadget(#port_d_0, 440, 285, 30, 30, "0", #PB_Button_Toggle)
    Frame3DGadget(#Frame3D_40, 5, 5, 490, 30, "Status")
    TextGadget(#State_Text_1, 65, 15, 320, 15, "Device Status")
    StringGadget(#port_b, 120, 220, 65, 20, "", #PB_String_BorderLess)
    StringGadget(#port_c, 120, 255, 65, 20, "", #PB_String_BorderLess)
    StringGadget(#port_d, 120, 290, 65, 20, "", #PB_String_BorderLess)
    EditorGadget(#RX_Text, 222, 57, 270, 115, #PB_Editor_ReadOnly)
    TextGadget(#Text_46, 223, 44, 20, 13, "RX")
    SpinGadget(#Spin_47, 20, 145, 50, 25, 0, 255, #PB_Spin_Numeric)
    ButtonGadget(#send_byte_ser, 75, 145, 40, 25, "Send", #PB_Button_Default)
    TextGadget(#Text_49, 20, 90, 85, 15, "send string")
    TextGadget(#Text_50, 20, 130, 85, 15, "send byte")
    Frame3DGadget(#Frame3D_51, 5, 325, 490, 105, "Infrared Data")
    ; Gadget Fonts
    SetGadgetFont(#Text_5, LoadFont(#Font_Text_5, "Microsoft Sans Serif", 10, 272))
    SetGadgetFont(#Frame3D_6, LoadFont(#Font_Frame3D_6, "Microsoft Sans Serif", 9, 272))
    SetGadgetFont(#Frame3D_7, LoadFont(#Font_Frame3D_7, "Microsoft Sans Serif", 9, 272))
    SetGadgetFont(#Text_8, LoadFont(#Font_Text_8, "Microsoft Sans Serif", 10, 272))
    SetGadgetFont(#Text_9, LoadFont(#Font_Text_9, "Microsoft Sans Serif", 10, 272))
    SetGadgetFont(#Text_10, LoadFont(#Font_Text_10, "Microsoft Sans Serif", 10, 272))
    SetGadgetFont(#Port_B_direction, LoadFont(#Font_Port_B_direction, "Microsoft Sans Serif", 10, 272))
    SetGadgetFont(#Port_C_direction, LoadFont(#Font_Port_C_direction, "Microsoft Sans Serif", 10, 272))
    SetGadgetFont(#Port_D_direction, LoadFont(#Font_Port_D_direction, "Microsoft Sans Serif", 10, 272))
    SetGadgetFont(#Frame3D_40, LoadFont(#Font_Frame3D_40, "Microsoft Sans Serif", 8, 272))
    SetGadgetFont(#State_Text_1, LoadFont(#Font_State_Text_1, "Microsoft Sans Serif", 9, 272))
    SetGadgetFont(#Frame3D_51, LoadFont(#Font_Frame3D_51, "Microsoft Sans Serif", 9, 272))
    ;
          AddGadgetItem(#ComboBox_Baud,0,"600")
          AddGadgetItem(#ComboBox_Baud,1,"1200")
          AddGadgetItem(#ComboBox_Baud,2,"2400")
          AddGadgetItem(#ComboBox_Baud,3,"4800")
          AddGadgetItem(#ComboBox_Baud,4,"9600")
          AddGadgetItem(#ComboBox_Baud,5,"19200")
          AddGadgetItem(#ComboBox_Baud,6,"28800")
          AddGadgetItem(#ComboBox_Baud,7,"38400")
          AddGadgetItem(#ComboBox_Baud,8,"57600")
          AddGadgetItem(#ComboBox_Baud,9,"115200")
          SetGadgetState(#ComboBox_Baud,4)
          AddWindowTimer(#Window_0, #Poll_Timer, 200)
          AddWindowTimer(#Window_0, #Receive_Timer, 100)
      
          ProcedureReturn  1
  EndIf
EndProcedure

Procedure AVR309_DLL_FREE(); DLL FREE
  If AVR309_DLL
    CloseLibrary(#PB_Any)
  EndIf
  XLTable_DLL = 0
EndProcedure

Procedure SET_USED_PORTS(UsedPorts.c )
Shared DataPortDirection()
   For y.c = 0 To 2
     For x.c = 0 To 9
       ;disable, if Port not availible
       DisableGadget((100 + (y * 10)) + x, 1 XOr (UsedPorts & (1 << y)) >> y)
       ;disable, if Pin not availible
       If x < 8
          DisableGadget((100 + (y * 10)) + x, 1 XOr ( DataPortDirection(y) & (1 << x)) >> x)
       EndIf
Next
   Next
EndProcedure

;{ Mainunit
If Open_Window_0()
      ;{ *** INIT         ***
          SetGadgetText(#port_b, RSet(Bin(PORTB), 8, "0") )
          SetGadgetText(#port_c, RSet(Bin(PORTC), 8, "0") )
          SetGadgetText(#port_d, RSet(Bin(PORTD), 8, "0") )
          SetGadgetState(#Spin_47, 0)
          ;Direction --> OUT
          ;jeder PIN!!! kann als Ein- oder Ausgang definiert werden.
          ;realisiert ist hier lediglich alle Ports als Ausgang!
          DoSetDataPortDirections(255,255,255, 1 << 0);
          DoSetDataPortDirections(255,255,255, 1 << 1);
          DoSetDataPortDirections(255,255,255, 1 << 2);
          DoGetDataPortDirections(@DataPortDirection(0), @DataPortDirection(1), @DataPortDirection(2), @UsedPorts) 
          SetGadgetText(#Port_B_direction, "OUT" )
          SetGadgetText(#Port_C_direction, "OUT" )
          SetGadgetText(#Port_D_direction, "OUT" )

          ; Set COM Params
;           Parity:
;                   0=none
;                   1=odd
;                   2=even
;                   3=mark
;                   4=space
;           Databits Values: 5, 6, 7, 8
;           Stop Bits: 1 = 0
;                      2 = 1
          DoSetRS232Baud( Val(GetGadgetText(#ComboBox_Baud)))
          DoSetRS232DataBits(8)
          DoSetRS232Parity(0)
          DoSetRS232StopBits(0)
       ;}
  Repeat
    EventID = WaitWindowEvent()
    Select EventID                        
      ;{ *** Timer event  ***
       Case #PB_Event_Timer
          Select EventGadget()
              Case #Poll_Timer
                  If DoGetDataPortDirections(@DataPortDirection(0), @DataPortDirection(1), @DataPortDirection(2), @UsedPorts) = NO_ERROR 
                      DoGetINDataPorts(@INPORTB, @INPORTC, @INPORTD, @UsedPorts)
                      DoGetOutDataPorts(@OUTPORTB, @OUTPORTC, @OUTPORTD, @UsedPorts)
                      SetGadgetText(#State_Text_1, "Device connected! "  ); 
                      If GetGadgetState(#Port_B_direction )
                         SetGadgetText(#port_b, RSet(Bin(INPORTB), 8, "0") )
                      Else
                         SetGadgetText(#port_b, RSet(Bin(OUTPORTB), 8, "0") )
                      EndIf
                      If GetGadgetState(#Port_C_direction )
                         SetGadgetText(#port_c, RSet(Bin(INPORTC), 8, "0") )
                      Else
                         SetGadgetText(#port_c, RSet(Bin(OUTPORTC), 8, "0") )
                      EndIf
                      If GetGadgetState(#Port_D_direction )
                         SetGadgetText(#port_d, RSet(Bin(INPORTD), 8, "0") )
                      Else
                         SetGadgetText(#port_d, RSet(Bin(OUTPORTD), 8, "0") )
                      EndIf
                      SET_USED_PORTS(UsedPorts)
                  Else
                      SetGadgetText(#State_Text_1, "Device not connected!"); 
                      SET_USED_PORTS(0)
                  EndIf
                  
                  ;get infrared receiver data
                  If DoGetInfraCode(InputInfraData(), dummy.l, @InfraBufferLength) = NO_ERROR
                    If InfraBufferLength > 0 
                      If StartDrawing(WindowOutput(#Window_0)) 
                         top.l = GadgetY(#Frame3D_51)   + 20
                         left.l = GadgetX(#Frame3D_51) + 5
                         height.l = 75 
                         bottom.l = top + height - 1 
                         faktor.f = 70 / 255
                         Box( left, top, InfraBufferLength, height, $006600)
                         For x.c = 0 To 3
                            Line(left, bottom - (x*20) ,255,1,$aaaaaa)
                         Next
                         For x.c = 0 To 12
                            Line(left + (x*20), top,1,height,$aaaaaa)
                         Next
                         For plot_x.l = 0 To InfraBufferLength
                             ;InputInfraData(plot_x) = Random(255)
                             Plot( left +plot_x, bottom - (faktor * InputInfraData(plot_x)), $00FF00)
                         Next
                         StopDrawing()  
                      EndIf
                    EndIf
                  EndIf
              Case #Receive_Timer
                  RS232BufferLength= ArraySize(InputRS232Data()) + 1
                  If (DoGetRS232Buffer(InputRS232Data() , dummy.l, @RS232BufferLength) = #NO_ERROR) 
                      If RS232BufferLength > 0 
                            ser$ = ""
                            For i.l = 0 To RS232BufferLength-1 
                                ser$ = ser$ + Chr(InputRS232Data(i))
                            Next
                            AddGadgetItem(#RX_Text,0,ser$)
                      EndIf
                  EndIf
                   
          EndSelect  
       ;}
      ;{ *** Button event ***  
       Case #PB_Event_Gadget
          button.l =  EventGadget() 
          Select button
             Case 100 To 107
                  If GetGadgetState(button )
                      PORTB = PORTB | (1 << (button - 100))
                  Else
                      PORTB = PORTB & (1 XOr (1 << (button - 100)))
                  EndIf
                  DoSetOutDataPorts(PORTB, PORTC, PORTD, UsedPorts)
             Case 110 To 117
                  If GetGadgetState(button )
                      PORTC = PORTC | (1 << (button - 110))
                  Else
                      PORTC = PORTC & (1 XOr (1 << (button - 110)))
                  EndIf
                  DoSetOutDataPorts(PORTB, PORTC, PORTD, UsedPorts)
             Case 120 To 127
                  If GetGadgetState(button )
                      PORTD = PORTD | (1 << (button - 120))
                  Else
                      PORTD = PORTD & (1 XOr (1 << (button - 120)))
                  EndIf
                  DoSetOutDataPorts(PORTB, PORTC, PORTD, UsedPorts)
             Case #send_ser
                  len.l = Len(GetGadgetText(#COM_String_0))
                  For x.c = 1 To len
                      InputRS232Data(x-1) = Asc(Mid(GetGadgetText(#COM_String_0),x,1))
                  Next
                  DoRS232BufferSend( @InputRS232Data(), dummy.l, @len)
                  SetGadgetText(#COM_String_0, "")
             Case #Port_B_direction
                  If GetGadgetState(button )
                      SetGadgetText(#Port_B_direction, "IN" )
                      DoSetDataPortDirections(0,0,0, 1);
                  Else
                      SetGadgetText(#Port_B_direction, "OUT" )
                      DoSetDataPortDirections(255,255,255, 1);
                  EndIf
                  DoGetDataPortDirections(@DataPortDirection(0), @DataPortDirection(1), @DataPortDirection(2), @UsedPorts)
                  SET_USED_PORTS(UsedPorts)
             Case #Port_C_direction
                  If GetGadgetState(button )
                      SetGadgetText(#Port_C_direction, "IN" )
                      DoSetDataPortDirections(0,0,0, 2);
                  Else
                      SetGadgetText(#Port_C_direction, "OUT" )
                      DoSetDataPortDirections(255,255,255, 2);
                  EndIf
                  DoGetDataPortDirections(@DataPortDirection(0), @DataPortDirection(1), @DataPortDirection(2), @UsedPorts)
                  SET_USED_PORTS(UsedPorts)
             Case #Port_D_direction
                  If GetGadgetState(button )
                      SetGadgetText(#Port_D_direction, "IN" )
                      DoSetDataPortDirections(0,0,0, 4);
                  Else
                      SetGadgetText(#Port_D_direction, "OUT" )
                      DoSetDataPortDirections(255,255,255, 4);
                  EndIf
                  DoGetDataPortDirections(@DataPortDirection(0), @DataPortDirection(1), @DataPortDirection(2), @UsedPorts)
                  SET_USED_PORTS(UsedPorts)
             Case #send_byte_ser
                  DoRS232Send(GetGadgetState(#Spin_47))
                  
          EndSelect
          
    EndSelect
   ;}
  Until EventID = #PB_Event_CloseWindow
  AVR309_DLL_FREE()
EndIf


End
;}
; IDE Options = PureBasic 4.40 Beta 6 (Windows - x86)
; CursorPosition = 304
; FirstLine = 302
; IDE Options = PureBasic 4.40 Beta 6 (Windows - x86)
; CursorPosition = 282
; Folding = BI+